"""Initial_version

Revision ID: d3b625401faa
Revises:
Create Date: 2021-05-19 11:55:37.441873+02:00

"""
import sqlalchemy as sa
from alembic import op
from alembic_utils.pg_function import PGFunction
from sqlalchemy.dialects import postgresql
from sqlalchemy.schema import CreateSequence, Sequence

# revision identifiers, used by Alembic.
revision = "d3b625401faa"
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # The next line is mannually added to make the sequence for the id
    op.execute(CreateSequence(Sequence("ContactMoment_id_seq")))

    # ### commands auto generated by Alembic - please adjust! ###
    public_contact_moment_generate_id = PGFunction(
        schema="public",
        signature="contact_moment_generate_id()",
        definition="RETURNS varchar\n        LANGUAGE plpgsql\n        AS $function$\n            DECLARE\n            v_result      varchar := 'CM-';\n            value_numeric numeric;\n            begin\n                SELECT nextval('\"ContactMoment_id_seq\"') INTO value_numeric;\n                IF value_numeric > 9999 THEN\n                    v_result := v_result || value_numeric;\n                ELSE\n                    v_result := v_result || to_char(value_numeric, 'FM0000');\n                END IF;\n                return v_result;\n            END;\n        $function$",  # noqa: E501
    )
    op.create_entity(public_contact_moment_generate_id)
    op.create_table(
        "CustomField",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("name", sa.String(), nullable=True),
        sa.Column("description", sa.String(), nullable=True),
        sa.Column("required", sa.Boolean(), nullable=True),
        sa.Column(
            "type",
            postgresql.ENUM("string", "text", "select", name="customfieldtypes"),
            nullable=False,
        ),
        sa.Column("sort_order", sa.Integer(), nullable=False),
        sa.Column("options", sa.JSON(), nullable=True),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(op.f("ix_CustomField_name"), "CustomField", ["name"], unique=True)
    op.create_index(op.f("ix_CustomField_sid"), "CustomField", ["sid"], unique=False)
    op.create_index(
        op.f("ix_CustomField_sort_order"),
        "CustomField",
        ["sort_order"],
        unique=False,
    )
    op.create_table(
        "Employee",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("name", sa.String(), nullable=True),
        sa.Column("email", sa.String(), nullable=True),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(op.f("ix_Employee_email"), "Employee", ["email"], unique=True)
    op.create_index(op.f("ix_Employee_name"), "Employee", ["name"], unique=True)
    op.create_index(op.f("ix_Employee_sid"), "Employee", ["sid"], unique=False)
    op.create_table(
        "ContactMoment",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "id",
            sa.String(),
            server_default=sa.text("contact_moment_generate_id()"),
            nullable=False,
        ),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("contact", sa.String(), nullable=True),
        sa.Column("employee_id", sa.Integer(), nullable=True),
        sa.Column("created_at", sa.DateTime(), nullable=True),
        sa.Column("updated_at", sa.DateTime(), nullable=True),
        sa.ForeignKeyConstraint(
            ["employee_id"],
            ["Employee.sid"],
        ),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(
        op.f("ix_ContactMoment_contact"),
        "ContactMoment",
        ["contact"],
        unique=False,
    )
    op.create_index(op.f("ix_ContactMoment_id"), "ContactMoment", ["id"], unique=True)
    op.create_index(op.f("ix_ContactMoment_sid"), "ContactMoment", ["sid"], unique=False)
    op.create_table(
        "CustomFieldValues",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column("contact_moment_id", sa.Integer(), nullable=True),
        sa.Column("custom_field_id", sa.Integer(), nullable=False),
        sa.Column("value", sa.String(), nullable=True),
        sa.ForeignKeyConstraint(
            ["contact_moment_id"],
            ["ContactMoment.sid"],
        ),
        sa.ForeignKeyConstraint(
            ["custom_field_id"],
            ["CustomField.sid"],
        ),
        sa.PrimaryKeyConstraint("sid"),
    )
    op.create_index(
        op.f("ix_CustomFieldValues_contact_moment_id"),
        "CustomFieldValues",
        ["contact_moment_id"],
        unique=False,
    )
    op.create_index(
        op.f("ix_CustomFieldValues_sid"),
        "CustomFieldValues",
        ["sid"],
        unique=False,
    )
    # ### end Alembic commands ###

    CustomField = sa.table(
        "CustomField",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("name", sa.String(), nullable=True),
        sa.Column("description", sa.String(), nullable=True),
        sa.Column("required", sa.Boolean(), nullable=True),
        sa.Column(
            "type",
            postgresql.ENUM("string", "text", "list", name="customfieldtypes"),
            nullable=False,
        ),
        sa.Column("sort_order", sa.Integer(), nullable=False),
        sa.Column("options", sa.JSON(), nullable=True),
    )

    op.bulk_insert(
        CustomField,
        [
            {
                "name": "Inkomend/Uitgaand",
                "description": "Met het registreren van een inkomend contact "
                + "moment registreer je dat een klant contact opneemt met je "
                + "organisatie. Bij een uitgaand contactmoment neemt de "
                + "organisatie zelf contact op met de klant.",
                "required": True,
                "type": "select",
                "sort_order": 1,
                "options": [
                    {"id": "inkomend", "name": "Inkomend"},
                    {"id": "uitgaand", "name": "Uitgaand"},
                ],
            },
            {
                "name": "Telefoonnummer",
                "description": "Het telefoonnummer van de klant",
                "required": False,
                "type": "string",
                "sort_order": 2,
                "options": None,
            },
            {
                "name": "Onderwerp",
                "description": "Waarover ging het contact",
                "required": True,
                "type": "string",
                "sort_order": 3,
                "options": None,
            },
            {
                "name": "Samenvatting",
                "description": "Een korte beschrijving van het contact",
                "required": False,
                "type": "text",
                "sort_order": 4,
                "options": None,
            },
            {
                "name": "Kanaal",
                "description": "Via welke weg heeft het contact plaats " + "gevonden",
                "required": True,
                "type": "select",
                "sort_order": 5,
                "options": [
                    {"id": "balie", "name": "Balie"},
                    {"id": "brief", "name": "Brief"},
                    {"id": "mail", "name": "Mail"},
                    {"id": "overig", "name": "Overig"},
                    {"id": "telefoon", "name": "Telefoon"},
                    {"id": "whatsapp", "name": "Whatsapp"},
                ],
            },
        ],
    )


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f("ix_CustomFieldValues_sid"), table_name="CustomFieldValues")
    op.drop_index(
        op.f("ix_CustomFieldValues_contact_moment_id"),
        table_name="CustomFieldValues",
    )
    op.drop_table("CustomFieldValues")
    op.drop_index(op.f("ix_ContactMoment_sid"), table_name="ContactMoment")
    op.drop_index(op.f("ix_ContactMoment_id"), table_name="ContactMoment")
    op.drop_index(op.f("ix_ContactMoment_contact"), table_name="ContactMoment")
    op.drop_table("ContactMoment")
    op.drop_index(op.f("ix_Employee_sid"), table_name="Employee")
    op.drop_index(op.f("ix_Employee_name"), table_name="Employee")
    op.drop_index(op.f("ix_Employee_email"), table_name="Employee")
    op.drop_table("Employee")
    op.drop_index(op.f("ix_CustomField_sid"), table_name="CustomField")
    op.drop_index(op.f("ix_CustomField_name"), table_name="CustomField")
    op.drop_table("CustomField")

    public_contact_moment_generate_id = PGFunction(
        schema="public",
        signature="contact_moment_generate_id()",
        definition="RETURNS varchar\n        LANGUAGE plpgsql\n        AS $function$\n            DECLARE\n            v_result      varchar := 'CM-';\n            value_numeric numeric;\n            begin\n                SELECT nextval('\"ContactMoment_id_seq\"') INTO value_numeric;\n                IF value_numeric > 9999 THEN\n                    v_result := v_result || value_numeric;\n                ELSE\n                    v_result := v_result || to_char(value_numeric, 'FM0000');\n                END IF;\n                return v_result;\n            END;\n        $function$",  # noqa: E501
    )
    op.drop_entity(public_contact_moment_generate_id)
    # ### end Alembic commands ###
